package com.kabronkline.jft.transfer;

import java.util.ArrayList;
import java.util.List;
import java.util.Queue;
import java.util.concurrent.Callable;

import com.kabronkline.jft.exception.FileTransferException;

public class FileTransferThread implements Callable<List<FileTransfer>> {
	private Queue<FileTransfer> transferQueue;
	private List<FileTransfer> fileTransfers;
	public FileTransferThread(Queue<FileTransfer> transferQueue) {
		this.transferQueue = transferQueue;
		this.fileTransfers = new ArrayList<FileTransfer>();
	}
	@Override
	public List<FileTransfer> call() throws FileTransferException {
		FileTransfer transfer = null;
		while ((transfer = transferQueue.poll()) != null) {
			transfer.transferFile();
			fileTransfers.add(transfer);
		}
		return fileTransfers;
	}
}
